! Copyright (c) 2020 Jeffrey Armstrong <jeff@rainbow-100.com>
!
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
!
! The above copyright notice and this permission notice shall be included in
! all copies or substantial portions of the Software.
!
! The Software shall be used for Good, not Evil.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
! SOFTWARE.

module escaper

    character(*), parameter::need_escape = " $&`:<>[]{}+#%@/;=?\^|~',"//'"'

contains

    subroutine escape_string(text)
    implicit none
    
        character(*), intent(inout)::text
        integer::i
        character(3)::replace_text
        integer::replace_code
        
        i=1
        do while(i < len_trim(text))
        
            if(index(need_escape, text(i:i)) > 0) then
                replace_code = iachar(text(i:i))
                write(replace_text, '(A1,Z2)') "%", replace_code
                if(i == 1) then
                    text = replace_text//text(2:len_trim(text))
                else if(i == len_trim(text)) then
                    text = text(1:(i-1))//replace_text
                else
                    text = text(1:(i-1))//replace_text//text((i+1):len_trim(text))
                end if
                i = i + 3
            else
                i = i + 1
            end if
        
        end do
    
    end subroutine escape_string

end module escaper